## ros-kinetic-object-recognition-tod 0.5.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(object_recognition_tod)

find_package(catkin REQUIRED cmake_modules ecto ecto_opencv object_recognition_core opencv_candidate)

catkin_package()

#install targets for all things python
catkin_python_setup()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

add_definitions("-Wno-pragmas -fno-strict-aliasing -Wall -Wl,--no-undefined")

find_package(Boost REQUIRED system filesystem serialization)
find_package(Eigen REQUIRED)
find_package(OpenCV REQUIRED)

include_directories(SYSTEM ${BOOST_INCLUDE_DIRS}
                           ${catkin_INCLUDE_DIRS}
                           ${EIGEN_INCLUDE_DIRS}
                           ${OpenCV_INCLUDE_DIRS}
)

add_subdirectory(src)
if(CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
endif()

# add docs
ecto_sphinx(${CMAKE_CURRENT_SOURCE_DIR}/doc/source doc)

# install the applications
install(PROGRAMS ${PROJECT_SOURCE_DIR}/apps/feature_viewer
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY conf
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== src/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/common)

# deal with the detection TOD module
ectomodule(ecto_detection DESTINATION ${PROJECT_NAME}
                          INSTALL  
                          detection/DescriptorMatcher.cpp
                          detection/GuessGenerator.cpp
                          detection/ModelReader.cpp
                          detection/module.cpp
                          common/adjacency_ransac.cpp
                          common/maximum_clique.cpp
)

link_ecto(ecto_detection ${OpenCV_LIBRARIES}
                         ${catkin_LIBRARIES} 
                         ${Boost_LIBRARIES}
)

# deal with the training TOD modules
ectomodule(ecto_training DESTINATION ${PROJECT_NAME}
                         INSTALL
                         training/ModelFiller.cpp
                         training/module.cpp
                         training/Trainer.cpp
                         training/training.cpp
                         common/adjacency_ransac.cpp
                         common/maximum_clique.cpp
)

link_ecto(ecto_training ${catkin_LIBRARIES}
                        ${OpenCV_LIBRARIES}
)

=== test/CMakeLists.txt ===
# pipeline tests
object_recognition_core_config_test(${CMAKE_CURRENT_SOURCE_DIR}/../conf/detection.ros.ork)
object_recognition_core_config_test(${CMAKE_CURRENT_SOURCE_DIR}/../conf/detection.ork)
object_recognition_core_config_test(${CMAKE_CURRENT_SOURCE_DIR}/../conf/training.ork)

if (ecto_pcl_FOUND)
  object_recognition_core_help_test(${CMAKE_CURRENT_SOURCE_DIR}/../apps/feature_viewer)
endif()

# clique test
include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src/common)

catkin_add_gtest(test_tod_clique main.cpp test_maximum_clique.cpp
                                   ../src/common/maximum_clique.cpp
)
find_package(PythonLibs REQUIRED)
target_link_libraries(test_tod_clique ${PYTHON_LIBRARIES}
                                      ${OpenCV_LIBRARIES}
)

=== debian/changelog ===
ros-kinetic-object-recognition-tod (0.5.6-0xenial) xenial; urgency=high

  * fix OpenCV3 compilation
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 23 Apr 2016 22:00:00 -0000

ros-kinetic-object-recognition-tod (0.5.5-0xenial) xenial; urgency=high

  * Fix seg fault while detecting objects
    In many cases, matches[i] contains less than 5 elements (varies seemingly random between 0 and 4)
    Long history available [here](https://github.com/plasmodic/ecto_opencv/commit/2f2fe7fb75d09337c1d594cee416bd948f337b30#commitcomment-10687068)
  * Contributors: Jorge Santos Simón

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 18 Apr 2015 22:00:00 -0000

ros-kinetic-object-recognition-tod (0.5.4-0xenial) xenial; urgency=high

  * fix radius search not support with LSH
  * remove useless code
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Tue, 14 Apr 2015 22:00:00 -0000

ros-kinetic-object-recognition-tod (0.5.3-0xenial) xenial; urgency=high

  * use OpenCV and not opencv_candidate for LSH
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 30 Mar 2015 22:00:00 -0000

ros-kinetic-object-recognition-tod (0.5.2-0xenial) xenial; urgency=high

  * add opencv_candidate as a dependency
    It is included but just transitively so it's better to have it
    directly
  * Revert "remove dependency on opencv_candidate"
    This reverts commit 3a515e48c815b9e0c7f6df20b730b98d0dccd5df.
    The RGBD module from opencv_candidate is indeed needed
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 29 Mar 2015 22:00:00 -0000

ros-kinetic-object-recognition-tod (0.5.1-0xenial) xenial; urgency=high

  * remove dependency on opencv_candidate
  * clean extensions
  * remove useless build dependency
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 28 Mar 2015 23:00:00 -0000

ros-kinetic-object-recognition-tod (0.5.0-0xenial) xenial; urgency=high

  * compile under Indigo
  * Merge pull request #6 <https://github.com/wg-perception/tod/issues/6> from awesomebytes/patch-2
    For some reason this is needed using openni
  * For some reason this is needed using openni
    This is just a workaround, the real problem is that the default values expect:
    ```[ INFO] [1395248076.002277778]: Subscribed to topic:/camera/rgb/camera_info with queue size of 1
    [ INFO] [1395248076.003073369]: Subscribed to topic:/camera/rgb/image_raw with queue size of 1
    [ INFO] [1395248076.003968179]: Subscribed to topic:/camera/depth_registered/camera_info with queue size of 1
    [ INFO] [1395248076.004994459]: Subscribed to topic:/camera/depth_registered/image_raw with queue size of 1
    ```
    Using openni2 this is not a problem as it's published by default but using openni those are not published, so this workarounds that.
  * Merge pull request #5 <https://github.com/wg-perception/tod/issues/5> from awesomebytes/patch-1
    Configuration that gives detections
  * Configuration that gives detections
    Tested with an Asus Xtion and 6 objects trained.
    The sink2 + adding to pipeline1 the output sink2 makes that /recognized_object_array has publications!
  * fix tests
  * add openni runtime dependency
  * fix the ROS config file to use ROS
  * drop Fuerte support
  * update url
  * udpate the docs
  * Merge pull request #3 <https://github.com/wg-perception/tod/issues/3> from destogl/ros_cell_config_correction
    Corrected cell cofing to work out-of-the-box with ROS.
  * Corrected cell cofing to work out of the box with ros.
    There was problem with wrong type and parameters cell is added.
  * fixes wg-perception/object_recognition_core#13 <https://github.com/wg-perception/object_recognition_core/issues/13>
  * Contributors: Denis Štogl, Sammy Pfeiffer, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 12 Apr 2014 22:00:00 -0000

ros-kinetic-object-recognition-tod (0.4.16-0xenial) xenial; urgency=high

  * use proper K_image/K_depth
  * update email address
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Tue, 28 May 2013 22:00:00 -0000

ros-kinetic-object-recognition-tod (0.4.15-0xenial) xenial; urgency=high

  * fix display
  * fix the 3d point non-sense
  * comply to the new core API
  * finally convert the Trainer fully to C++
  * remove old split modules in favor of one cell
  * comply to the new DB API
  * implement moreof the pipeline
  * comply to the new headers in core
  * add a Trainer cell to replace the Python mess
  * make the cell contents be in a common library-like file
  * fix the pipeline
  * fix the invalid plasm
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 13 Apr 2013 22:00:00 -0000

ros-kinetic-object-recognition-tod (0.4.14-0xenial) xenial; urgency=high

  * comply to the new DB API
  * fix a Sphinx warning
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 11 Mar 2013 23:00:00 -0000

ros-kinetic-object-recognition-tod (0.4.13-0xenial) xenial; urgency=high

  * comply to the tighter BlackBox API
  * comply to the API
  * fix a member that can be static
  * remove rst warning
  * build its own docs
  * get the training test to pass
  * rename the config files
  * clean the CMake
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 24 Feb 2013 23:00:00 -0000

ros-kinetic-object-recognition-tod (0.4.12-0xenial) xenial; urgency=high

  * comply to the new ORK API
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Wed, 16 Jan 2013 23:00:00 -0000

ros-kinetic-object-recognition-tod (0.4.11-0xenial) xenial; urgency=high

  * use the new DB API
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 12 Jan 2013 23:00:00 -0000

ros-kinetic-object-recognition-tod (0.4.10-0xenial) xenial; urgency=high



=== debian/control ===
Source: ros-kinetic-object-recognition-tod
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-ecto, ros-kinetic-object-recognition-core, ros-kinetic-opencv-candidate
Homepage: http://wg-perception.github.io/tod/
Standards-Version: 3.9.2

Package: ros-kinetic-object-recognition-tod
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-ecto, ros-kinetic-ecto-opencv, ros-kinetic-ecto-openni, ros-kinetic-object-recognition-core, ros-kinetic-opencv-candidate
Description: Textured Object Recognition a standard bag of features approach

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-object-recognition-tod//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
